; Published M100 ROM routines and locations library file
; for TASM32


; LCD functions and escape codes

CRLF	.equ	4222H
HOME	.equ	422DH
CLS	.equ	4231H
SETSYS	.equ	4235H
RSTSYS	.equ	423AH
LOCK	.equ	423FH
UNLOCK	.equ	4244H
CURSON	.equ	4249H
CUROFF	.equ	424EH
DELLIN	.equ	4253H
INSLIN	.equ	4258H
ERAEOL	.equ	425DH
ENTREV	.equ	4269H
EXTREV	.equ	426EH


; LCD variable and status locations

CSRY	.equ	0F639H
CSRX	.equ	0F63AH
BEGLCD	.equ	0FE00H
ENDLCD	.equ	0FF40H

; Directory Table

DIRTBL	.equ	0F962H

; LCD functions
LCD	.equ	4313H		; fast
;LCD	.equ 	4B44H		; slow, more functions
PLOT	.equ	744CH
UNPLOT	.equ	744DH
POSIT	.equ	427CH
ESCA	.equ	4270H

; Keyboard functions

BRKCHK	.equ	7283H
INLIN	.equ	4644H
STFNK	.equ	5A7CH
KYREAD	.equ	7242H
CHGET	.equ	12CBH
CHSNS	.equ	13DBH
KEYX	.equ	7270H
CLRFLK	.equ	5A79H
DSPFNK	.equ	42A8H
STDSPF	.equ	42A5H
ERAFNK	.equ	428AH
FNKSB	.equ	5A9EH

; Printer Functions

PRINTR	.equ	6D3FH
PNOTAB	.equ	1470H
PRTTAB	.equ	4B55H
PRTLCD	.equ	1E5EH

; RS232 and Modem functions

DISC	.equ	52BBH
CONN	.equ	52D0H
DIAL	.equ	53D2H
RCVX	.equ	6D6DH
RV232C	.equ	6D7EH
SENDCQ	.equ	6E0BH
SENDCS	.equ	6E1EH
SD232C	.equ	6E32H
CARDET	.equ	6EEFH
BAUDST	.equ	6E75H
INZCOM	.equ	6EA6H
SETSER	.equ	17E6H
CLDCOM	.equ	6ECBH

; Cassette functions

CTON	.equ	14A8H
CTOFF	.equ	14AAH
CASIN 	.equ	14B0H
CSOUT	.equ	14C1H
SYNCW	.equ	6F46H
SYNCR	.equ	6F85H
DATAW	.equ	6F5BH
DATAR	.equ	702AH

; Other routines

MUSIC	.equ	725CH
TIME	.equ	190FH
DATE 	.equ	192FH
DAY 	.equ	1962H
INITIO	.equ	6CD6H
IOINIT	.equ	6CE0H
MENU	.equ	5797H


; Ram file functions

MAKTXT 	.equ	220FH
CHKDC	.equ	5AA9H
GTXTTB	.equ	5A3BH
KILASC	.equ	1FBEH
INSCHR	.equ	6B61H
MAKHOL	.equ	6B6DH
MASDEL	.equ	6B9FH



